<TeXmacs|1.99.5>

<style|<tuple|beamer|blackboard>>

<\body>
  <\hide-preamble>
    <assign|vl|<macro|<with|font|roman|font-family|rm|\<ell\>>>>

    <assign|vl|<macro|<space|-0.5spc><with|font|Chalkduster|\<ell\>><space|-0.5spc>>>
  </hide-preamble>

  <screens|<\hidden>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        <strong|<strong|<with|font-series|bold|Fast Chinese remaindering in
        practice>>>
      </with>>

      <with|font|Chalkduster|Joris van der Hoeven>

      <small|<with|font|Chalkduster|CNRS, cole polytechnique>>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<table|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|sunzi_web.gif|412px|||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Vienna,
      November 16, 2017<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|pastel
      brown|T<space|-0.2spc><with|color|pastel
      brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|pastel
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|pastel
      green|T<space|-0.2spc><with|color|pastel
      brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|pastel
      brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </hidden>|<\shown>
    <tit|Example: integer matrix multiplication <em|via> Chinese
    remaindering>

    <switch|<\shown>
      <unroll|<\shown>
        <strong|Integer matrix multiplication>

        <\compact>
          <\equation*>
            <tabular*|<tformat|<table|<row|<cell|<with|color|green|M>\<in\>\<bbb-Z\><rsup|n\<times\>n>>|<cell|<space|5.0em>>|<cell|<with|color|green|N>\<in\>\<bbb-Z\><rsup|n\<times\>n>>>|<row|<cell|<around*|\||M<rsub|i,j>|\|>\<less\>2<rsup|p>>|<cell|>|<cell|<around*|\||N<rsub|i,j>|\|>\<less\>2<rsup|p>>>|<row|<cell|>|<cell|<with|color|#f44|P>=M*N>|<cell|>>|<row|<cell|>|<cell|<around*|\||P<rsub|i,j>|\|>\<less\>n*2<rsup|2*p>>|<cell|>>>>>
          </equation*>
        </compact>
      </shown>|<\shown>
        <strong|Pick primes>

        <\compact>
          <\equation*>
            <tabular*|<tformat|<table|<row|<cell|p<rsub|1>,\<ldots\>,p<rsub|<vl>><text|
            pairwise distinct primes>>>|<row|<cell|p<rsub|1>*\<cdots\>*p<rsub|n>\<geqslant\>2*n*2<rsup|2*p>>>|<row|<cell|p<rsub|k>\<less\>2<rsup|<tiny-switch|<hidden|52>|<hidden|26>|<shown|23>>>>>>>>
          </equation*>
        </compact>
      </shown>|<\hidden*>
        <\compact>
          <strong|Multi-modular reduction>

          <\compact>
            <\equation*>
              <tabular*|<tformat|<table|<row|<cell|M<rsub|k>=M mod
              p<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>>|<cell|<space|5.0em>>|<cell|N<rsub|k>=N
              mod p<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>>>>>>
            </equation*>
          </compact>
        </compact>
      </hidden*>|<\hidden*>
        <\compact>
          <strong|Modular multiplications>

          <\compact>
            <\equation*>
              P<rsub|k>=M<rsub|k>*N<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>
            </equation*>
          </compact>
        </compact>
      </hidden*>|<\hidden*>
        <\compact>
          <strong|Multi-modular reconstruction (Chinese remaindering)>

          <\compact>
            <\equation*>
              P<rsub|1>,\<ldots\>,P<rsub|<vl>>\<longmapsto\>P
            </equation*>
          </compact>
        </compact>
      </hidden*>>
    </shown>|<\hidden>
      <\compact>
        <strong|Integer matrix multiplication>

        <\compact>
          <\equation*>
            <tabular*|<tformat|<table|<row|<cell|<with|color|dark
            green|M>\<in\>\<bbb-Z\><rsup|n\<times\>n>>|<cell|<space|5.0em>>|<cell|<with|color|dark
            green|N>\<in\>\<bbb-Z\><rsup|n\<times\>n>>>|<row|<cell|<around*|\||M<rsub|i,j>|\|>\<less\>2<rsup|p>>|<cell|>|<cell|<around*|\||N<rsub|i,j>|\|>\<less\>2<rsup|p>>>|<row|<cell|>|<cell|<with|color|red|P>=M*N>|<cell|>>|<row|<cell|>|<cell|<around*|\||P<rsub|i,j>|\|>\<less\>n*2<rsup|2*p>>|<cell|>>>>>
          </equation*>
        </compact>
      </compact>

      <strong|Pick primes>

      <\compact>
        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|p<rsub|1>,\<ldots\>,p<rsub|<vl>><text|
          pairwise distinct primes>>>|<row|<cell|p<rsub|1>*\<cdots\>*p<rsub|n>\<geqslant\>2*n*2<rsup|2*p>>>|<row|<cell|p<rsub|k>\<less\>2<rsup|23>>>>>>
        </equation*>
      </compact>

      <\compact>
        <strong|Multi-modular reduction><tiny-switch|<shown|<phantom|
        <math|\<rightsquigarrow\>> cost <math|O<around*|(|\<ell\><rsup|2>*n<rsup|2>|)>>>>|<hidden|
        <math|<with|color|#88f|\<rightsquigarrow\>>> <with|color|#88f|cost>
        <math|<with|color|#88f|O<around*|(|<vl><rsup|2>*n<rsup|2>|)>>>>>

        <\equation*>
          <tabular*|<tformat|<table|<row|<cell|M<rsub|k>=M mod
          p<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>>|<cell|<space|5.0em>>|<cell|N<rsub|k>=N
          mod p<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>>>>>>
        </equation*>
      </compact>

      <\compact>
        <strong|Modular multiplications><tiny-switch|<shown|<phantom|
        <math|\<rightsquigarrow\>> cost <math|O<around*|(|\<ell\><rsup|2>*n<rsup|2>|)>>>>|<hidden|
        <math|<with|color|#88f|\<rightsquigarrow\>>> <with|color|#88f|cost>
        <math|<with|color|#88f|O<around*|(|<vl>*n<rsup|3>|)>>>>>

        <\equation*>
          P<rsub|k>=M<rsub|k>*N<rsub|k>\<in\>\<bbb-F\><rsub|p<rsub|k>><rsup|n\<times\>n>
        </equation*>
      </compact>

      <\compact>
        <strong|Multi-modular reconstruction (Chinese
        remaindering)><tiny-switch|<shown|<phantom|
        <math|\<rightsquigarrow\>> cost <math|O<around*|(|\<ell\><rsup|2>*n<rsup|2>|)>>>>|<hidden|
        <math|<with|color|#88f|\<rightsquigarrow\>>> <with|color|#88f|cost>
        <math|<with|color|#88f|O<around*|(|<vl><rsup|2>*n<rsup|2>|)>>>>>

        <\equation*>
          P<rsub|1>,\<ldots\>,P<rsub|<vl>>\<longmapsto\>P
        </equation*>
      </compact>
    </hidden>>
  </shown>|<\hidden>
    <tit|The challenge>

    \;

    <unroll|<\shown>
      <\quote-env>
        <em|<large|How to reduce the <math|O<around*|(|<vl><rsup|2>|)>> cost
        of multi-modular reduction and Chinese remaindering for small values
        of <math|<vl>><space|0.2spc>?><vspace|1.5fn>>
      </quote-env>
    </shown>|<\hidden*>
      <strong|Observation I>

      Many (namely <math|\<Theta\><around*|(|n<rsup|2>|)>>)
      reductions/reconstructions with respect to the same moduli.

      <math|\<rightsquigarrow\>> We are allowed to perform pre-computations
      as a function of <math|p<rsub|1>,\<ldots\>,p<rsub|<vl>>><vspace|1fn>
    </hidden*>|<\hidden*>
      <strong|Observation II>

      We are free to choice the moduli <math|p<rsub|1>,\<ldots\>,p<rsub|<vl>>>
      as long as they satisfy the size constraints

      <math|\<rightsquigarrow\>> Can we pick special primes that allow for
      speed-ups?
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Previous work>

    <unroll|<\shown>
      <strong|Asymptotically fast algorithms>

      <\itemize>
        <unroll|<\shown>
          <\compact>
            <item>Remainder trees <math|\<rightsquigarrow\>>
            <math|O<around*|(|<math-ss|I><around*|(|<vl>|)>*log <vl>|)>>

            Fiduccia 1972, Moenck\UBorodin 1972\U1974<vspace|0.5fn>

            <math|<math-ss|I><around*|(|<vl>|)>>: complexity of
            <math|<vl>>-bit integer multiplication

            <math|<math-ss|I><around*|(|<vl>|)>=O<around*|(|<vl>*log
            <vl>*K<rsup|log<rsup|\<ast\>> <vl>>|)>>, with
            <math|K=<with|math-display|true|<choice|<tformat|<table|<row|<cell|6>|<cell|<text|[Harvey
            2017]>>>|<row|<cell|4>|<cell|<text|[Harvey\UvdH\ULecerf 2014,
            prime hypothesis]>>>>>>>>
          </compact>
        </shown>|<\hidden*>
          <item><math|O<around*|(|<math-ss|I><around*|(|<vl>|)>*log <vl>|)>>
          with improved constants: Bostan\ULecerf\USchost 2003, Bernstein
          2004
        </hidden*>|<\hidden*>
          <item><math|O<around*|(|<math-ss|I><around*|(|<vl>|)>*<frac|log
          <vl>|log log <vl>>|)>> modulo pre-computations: vdH 2017
        </hidden*>>
      </itemize>
    </shown>|<\hidden*>
      <strong|Faster algorithms for small <math|<vl>>>

      <\itemize>
        <unroll|<\shown>
          <item>Implementing fast modular arithmetic: vdH\ULecerf\UQuintin
          2016
        </shown>|<\hidden*>
          <\compact>
            <item>Reduction to fast linear algebra modulo pre-computations

            Doliskani\UGiorgi\ULebreton\USchost 2017
          </compact>
        </hidden*>>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Special prime numbers>

      <\itemize>
        <\compact>
          <item>Pseudo-Mersenne primes <math|p<rsub|k>=2<rsup|n>-\<varepsilon\>>:
          cryptography, different complexity model

          Bajard\UKaihara\UPlantard 2009
        </compact>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Pseudo Mersenne moduli (I)>

    <unroll|<\shown>
      <\itemize>
        <item><math|w>: suitable bitsize for fast machine modular arithmetic:
        <math|w=48>, <math|w=23>, etc.

        <item><math|s>: small positive integer, typically
        <math|4\<leqslant\>s\<leqslant\>8>.<vspace|0.5fn>
      </itemize>
    </shown>|<\hidden*>
      <\compact>
        <strong|Idea: design fast conversions for pseudo-Mersenne moduli
        <math|m<rsub|1>,\<ldots\>,m<rsub|\<ell\>>>>

        <\eqnarray*>
          <tformat|<table|<row|<cell|m<rsub|i>>|<cell|=>|<cell|2<rsup|s*w>+\<delta\><rsub|i><space|2em><around*|(|i=1,\<ldots\>,<vl>|)>>>|<row|<cell|<around*|\||\<delta\><rsub|i>|\|>>|<cell|\<less\>>|<cell|2<rsup|w>>>>>
        </eqnarray*>
      </compact>
    </hidden*>|<\hidden*>
      <vspace*|0.5fn><strong|The three numbering systems>

      <\itemize>
        <item><math|0\<leqslant\>x\<less\>m<rsub|1>*\<cdots\>*m<rsub|<vl>>>:
        <with|color|#88f|usual binary representation>

        <item><math|<rigid|<around*|(|a<rsub|1>,\<ldots\>,a<rsub|<vl>>|)>>=<around*|(|x
        rem m<rsub|1>,\<ldots\>,x rem m<rsub|<vl>>|)>>:
        <with|color|#88f|multi-modular representation>

        <item><math|x=b<rsub|1>+b<rsub|2>*m<rsub|1>+b<rsub|3>*m<rsub|1>*m<rsub|2>+\<cdots\>+b<rsub|<vl>>*m<rsub|1>*\<cdots\>*m<rsub|<vl>-1>>:
        <with|color|#88f|mixed radix representation><vspace|0.5fn>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Binary representation <math|\<rightsquigarrow\>> multi-modular
      representation>

      <\itemize>
        <item>Euclidean division by <math|m<rsub|i>>
        <math|\<longrightarrow\>> multiplication of quotient by
        <math|\<delta\><rsub|i>>

        <item>Division by <math|<around*|(|s*w|)>>-bit number
        <math|\<longrightarrow\>> multiplication by <math|w>-bit number
        <math|\<longrightarrow\>> speed-up <math|\<approx\>2*s>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Pseudo Mersenne moduli (II)>

    <\compact>
      <\itemize>
        <item><math|m<rsub|i>=2<rsup|s*w>+\<delta\><rsub|i>>

        <item><math|<rigid|<around*|(|a<rsub|1>,\<ldots\>,a<rsub|<vl>>|)>>=<around*|(|x
        rem m<rsub|1>,\<ldots\>,x rem m<rsub|<vl>>|)>>

        <item><math|x=b<rsub|1>+b<rsub|2>*m<rsub|1>+b<rsub|3>*m<rsub|1>*m<rsub|2>+\<cdots\>+b<rsub|<vl>>*m<rsub|1>*\<cdots\>*m<rsub|<vl>-1>>
      </itemize>
    </compact>

    <strong|Multi-modular representation <math|\<rightsquigarrow\>> mixed
    radix representation>

    <\compact>
      <\eqnarray*>
        <tformat|<table|<row|<cell|b<rsub|1>>|<cell|=>|<cell|a<rsub|1>>>>>
      </eqnarray*>

      For <math|i\<geqslant\>2>, compute

      <\eqnarray*>
        <tformat|<table|<row|<cell|u<rsub|j,i>>|<cell|=>|<cell|<around*|(|b<rsub|j>+b<rsub|j+1>*m<rsub|j>+\<cdots\>+b<rsub|i-1>*m<rsub|j>*\<cdots\>*m<rsub|i-2>|)>
        rem m<rsub|i>>>>>
      </eqnarray*>

      using Horner

      <\eqnarray*>
        <tformat|<table|<row|<cell|u<rsub|i-1,i>>|<cell|=>|<cell|b<rsub|i-1>>>|<row|<cell|u<rsub|j,i>>|<cell|=>|<cell|<around*|(|b<rsub|j>+u<rsub|j+1,i>\<cdot\><tiny-switch|<shown|<with|color|#f44|m<rsub|j>>>|<hidden|<with|color|#f44|<around*|(|\<delta\><rsub|j>-\<delta\><rsub|i>|)>>>>|)>
        rem m<rsub|i><space|2em><around*|(|j=i-2,\<ldots\>,1|)>>>>>
      </eqnarray*>

      We have

      <\eqnarray*>
        <tformat|<table|<row|<cell|x rem m<rsub|i>>|<cell|=>|<cell|<around*|(|u<rsub|1,i>+b<rsub|i>*m<rsub|1>*\<cdots\>*m<rsub|i-1>|)>
        rem m<rsub|i><space|0.6spc>=<space|0.6spc>a<rsub|i>.>>>>
      </eqnarray*>

      The inverse <math|v<rsub|i>> of <math|m<rsub|1>*\<cdots\>*m<rsub|i-1>>
      modulo <math|m<rsub|i>> can be precomputed. Now

      <\eqnarray*>
        <tformat|<table|<row|<cell|b<rsub|i>>|<cell|=>|<cell|v<rsub|i>*<around*|(|a<rsub|i>-u<rsub|1,i>|)>
        rem m<rsub|i>.>>>>
      </eqnarray*>
    </compact>
  </hidden>|<\hidden>
    <tit|Pseudo Mersenne moduli (III)>

    <\compact>
      <\itemize>
        <item><math|m<rsub|i>=2<rsup|s*w>+\<delta\><rsub|i>>

        <item><math|<rigid|<around*|(|a<rsub|1>,\<ldots\>,a<rsub|<vl>>|)>>=<around*|(|x
        rem m<rsub|1>,\<ldots\>,x rem m<rsub|<vl>>|)>>

        <item><math|x=b<rsub|1>+b<rsub|2>*m<rsub|1>+b<rsub|3>*m<rsub|1>*m<rsub|2>+\<cdots\>+b<rsub|<vl>>*m<rsub|1>*\<cdots\>*m<rsub|<vl>-1>>
      </itemize>
    </compact>

    <strong|Mixed radix representation <math|\<rightsquigarrow\>> binary
    representation>

    <\compact>
      Horner style evaluation: for <math|i=<vl>,\<ldots\>,1>, compute

      <\eqnarray*>
        <tformat|<table|<row|<cell|x<rsub|i>>|<cell|=>|<cell|b<rsub|i>+b<rsub|i+1>*m<rsub|i>+\<cdots\>+b<rsub|\<ell\>>*m<rsub|i>*\<cdots\>*m<rsub|\<ell\>-1>>>>>
      </eqnarray*>

      using the recurrence relation

      <\eqnarray*>
        <tformat|<table|<row|<cell|x<rsub|i>>|<cell|=>|<cell|b<rsub|i>+x<rsub|i+1>*m<rsub|i>.>>>>
      </eqnarray*>
    </compact>

    <strong|Complexity analysis>

    <\itemize>
      <item>Binary <math|\<rightsquigarrow\>> multi-modular representation:
      <math|\<sim\><vl><rsup|2>*s> hardware multiplications

      <item>Multi-modular <math|\<rightsquigarrow\>> binary representation:
      <math|\<sim\><vl>*s*<around*|(|<vl>+s|)>> hardware multiplications
    </itemize>
  </hidden>|<\hidden>
    <tit|Gentle moduli>

    <\with|par-par-sep|0.3333fn>
      <unroll|<\shown>
        <strong|Main idea>

        <\itemize>
          <unroll|<\shown>
            <item>For the moment, our pseudo Mersenne moduli
            <math|m<rsub|i>=2<rsup|s*w>+\<delta\><rsub|i>> are too large.
          </shown>|<\hidden*>
            <item>We really need pseudo Mersenne moduli <math|m<rsub|i>> that
            can be factored

            <\eqnarray*>
              <tformat|<table|<row|<cell|m<rsub|i>>|<cell|=>|<cell|m<rsub|i,1>*\<cdots\>*m<rsub|i,s>>>|<row|<cell|m<rsub|i,j>>|<cell|\<less\>>|<cell|2<rsup|\<mu\>>>>>>
            </eqnarray*>
          </hidden*>|<\hidden*>
            <item>Here <math|\<mu\>> is the bit-size for machine modular
            arithmetic (slightly larger than <math|s>)
          </hidden*>|<\hidden*>
            <item>We also need to require that the <math|m<rsub|i,j>> are
            pairwise coprime<vspace|0.5fn>
          </hidden*>>
        </itemize>
      </shown>|<\hidden*>
        <strong|Gentle moduli>

        <\itemize>
          <item><math|s>-gentle moduli: <math|m<rsub|i,1>,\<ldots\>,m<rsub|i,s>>
          of the above type

          <item>Binary <math|\<leftrightarrow\>> multi-modular
          representation: <math|\<sim\><vl>*s*<around*|(|<vl>+2*s|)>>
          hardware multiplications<vspace|0.5fn>
        </itemize>
      </hidden*>|<\hidden*>
        <strong|Additional trick>

        <\itemize>
          <item>Taking <math|s> even and <math|\<delta\><rsub|i>=-\<varepsilon\><rsub|i><rsup|2>>,
          we already have <math|m<rsub|i>=<around*|(|2<rsup|s*w/2>+\<varepsilon\><rsub|i>|)>*<around*|(|2<rsup|s*w/2>-\<varepsilon\><rsub|i>|)>>

          <item>Conversions <math|\<bbb-Z\>/<around*|(|m<rsub|i>*\<bbb-Z\>|)>\<cong\>\<bbb-Z\>/<around*|(|<around*|(|2<rsup|s*w/2>+\<varepsilon\><rsub|i>|)>*\<bbb-Z\>|)>\<times\>\<bbb-Z\>/<around*|(|<around*|(|2<rsup|s*w/2>-\<varepsilon\><rsub|i>|)>*\<bbb-Z\>|)>>
          are fast

          <item><strong|super <math|s>-gentle moduli>:
          <math|2<rsup|s*w/2>+\<varepsilon\><rsub|i>=m<rsub|i,1>*\<cdots\>*m<rsub|i,s/2>>
          and <math|2<rsup|s*w/2>-\<varepsilon\><rsub|i>=m<rsub|i,s/2+1>*\<cdots\>*m<rsub|i,s>>
        </itemize>
      </hidden*>>
    </with>
  </hidden>|<\hidden>
    <tit|The gentle modulus hunt (I)>

    <\compact>
      <\itemize>
        <item>Determine <math|m<rsub|i,j>> once and for all for the desired
        size parameters <math|s,w,\<mu\>>, etc.

        <item>We implemented a sieving procedure in <name|Mathemagix>, making
        use of <name|Pari-GP>.
      </itemize>
    </compact>

    <\big-table*|<small|<tabular*|<tformat|<cwith|1|-1|1|-1|cell-halign|r>|<cwith|3|3|1|1|cell-background|dark
    magenta>|<cwith|5|6|1|1|cell-background|dark
    magenta>|<cwith|11|11|1|1|cell-background|dark
    magenta>|<cwith|13|16|1|1|cell-background|dark
    magenta>|<cwith|18|18|1|1|cell-background|dark
    magenta>|<cwith|3|3|8|8|cell-background|dark
    magenta>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|2|2|1|-1|cell-tsep|1spc>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|19|19|1|1|cell-bborder|0ln>|<cwith|1|-1|1|1|cell-lborder|0ln>|<cwith|1|-1|1|1|cell-rborder|1ln>|<cwith|1|-1|2|2|cell-lborder|1ln>|<cwith|1|1|8|8|cell-tborder|0ln>|<cwith|19|19|8|8|cell-bborder|0ln>|<cwith|1|-1|8|8|cell-lborder|1ln>|<cwith|1|-1|7|7|cell-rborder|1ln>|<cwith|1|-1|8|8|cell-rborder|0ln>|<table|<row|<cell|<math|\<varepsilon\>>>|<cell|<math|m<rsub|1>>>|<cell|<math|m<rsub|2>>>|<cell|<math|m<rsub|3>>>|<cell|<math|m<rsub|4>>>|<cell|<math|m<rsub|5>>>|<cell|<math|m<rsub|6>>>|<cell|<math|p<rsub|1><rsup|\<nu\><rsub|1>>,p<rsub|2><rsup|\<nu\><rsub|2>>,\<ldots\>>>>|<row|<cell|27657>|<cell|28867>|<cell|4365919>|<cell|6343559>|<cell|13248371>|<cell|20526577>|<cell|25042063>|<cell|<math|29,41,43,547,\<ldots\>>>>|<row|<cell|57267>|<cell|416459>|<cell|1278617>|<cell|2041469>|<cell|6879443>|<cell|25754563>|<cell|28268089>|<cell|<math|416459,\<ldots\>>>>|<row|<cell|77565>|<cell|7759>|<cell|8077463>|<cell|8261833>|<cell|18751793>|<cell|19509473>|<cell|28741799>|<cell|<math|59,641,\<ldots\>>>>|<row|<cell|95253>|<cell|724567>|<cell|965411>|<cell|3993107>|<cell|4382527>|<cell|19140643>|<cell|23236813>|<cell|<math|43,724567,\<ldots\>>>>|<row|<cell|294537>|<cell|190297>|<cell|283729>|<cell|8804561>|<cell|19522819>|<cell|19861189>|<cell|29537129>|<cell|<math|23<rsup|2>,151,1879,\<ldots\>>>>|<row|<cell|311385>|<cell|145991>|<cell|4440391>|<cell|4888427>|<cell|6812881>|<cell|7796203>|<cell|32346631>|<cell|<math|17,79,131,\<ldots\>>>>|<row|<cell|348597>|<cell|114299>|<cell|643619>|<cell|6190673>|<cell|11389121>|<cell|32355397>|<cell|32442427>|<cell|<math|31,277,\<ldots\>>>>|<row|<cell|376563>|<cell|175897>|<cell|1785527>|<cell|2715133>|<cell|7047419>|<cell|30030061>|<cell|30168739>|<cell|<math|17,127,1471,\<ldots\>>>>|<row|<cell|462165>|<cell|39841>|<cell|3746641>|<cell|7550339>|<cell|13195943>|<cell|18119681>|<cell|20203643>|<cell|<math|67,641,907,\<ldots\>>>>|<row|<cell|559713>|<cell|353201>|<cell|873023>|<cell|2595031>|<cell|11217163>|<cell|18624077>|<cell|32569529>|<cell|<math|19,59,14797,\<ldots\>>>>|<row|<cell|649485>|<cell|21727>|<cell|1186571>|<cell|14199517>|<cell|15248119>|<cell|31033397>|<cell|31430173>|<cell|<math|19,109,227,\<ldots\>>>>|<row|<cell|656997>|<cell|233341>|<cell|1523807>|<cell|5654437>|<cell|8563679>|<cell|17566069>|<cell|18001723>|<cell|<math|79,89,63533,\<ldots\>>>>|<row|<cell|735753>|<cell|115151>|<cell|923207>|<cell|3040187>|<cell|23655187>|<cell|26289379>|<cell|27088541>|<cell|<math|53,17419,\<ldots\>>>>|<row|<cell|801687>|<cell|873767>|<cell|1136111>|<cell|3245041>|<cell|7357871>|<cell|8826871>|<cell|26023391>|<cell|<math|23,383777,\<ldots\>>>>|<row|<cell|826863>|<cell|187177>|<cell|943099>|<cell|6839467>|<cell|11439319>|<cell|12923753>|<cell|30502721>|<cell|<math|73,157,6007,\<ldots\>>>>|<row|<cell|862143>|<cell|15373>|<cell|3115219>|<cell|11890829>|<cell|18563267>|<cell|19622017>|<cell|26248351>|<cell|<math|31,83,157,\<ldots\>>>>|<row|<cell|877623>|<cell|514649>|<cell|654749>|<cell|4034687>|<cell|4276583>|<cell|27931549>|<cell|33525223>|<cell|<math|41,98407,\<ldots\>>>>|<row|<cell|892455>|<cell|91453>|<cell|2660297>|<cell|3448999>|<cell|12237457>|<cell|21065299>|<cell|25169783>|<cell|<math|29,397,2141,\<ldots\>>>>>>>>>
      List of <math|6>-gentle moduli for <math|w=22>, <math|\<mu\>=25>, and
      <math|\<varepsilon\>\<less\>1000000>.
    </big-table*>
  </hidden>|<\hidden>
    <tit|The gentle modulus hunt (II)>

    \;

    <\big-table*|<small|<tabular*|<tformat|<cwith|1|-1|1|-1|cell-halign|r>|<cwith|3|3|1|1|cell-background|dark
    magenta>|<cwith|5|5|1|1|cell-background|dark
    magenta>|<cwith|9|9|1|1|cell-background|dark
    magenta>|<cwith|11|12|1|1|cell-background|dark
    magenta>|<cwith|3|3|8|8|cell-background|dark
    magenta>|<cwith|5|5|8|8|cell-background|dark
    magenta>|<cwith|9|9|8|8|cell-background|dark
    magenta>|<cwith|11|11|8|8|cell-background|dark
    magenta>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|-1|cell-bsep|1spc>|<cwith|2|2|1|-1|cell-tsep|1spc>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|12|12|1|1|cell-bborder|0ln>|<cwith|1|-1|1|1|cell-lborder|0ln>|<cwith|1|-1|1|1|cell-rborder|1ln>|<cwith|1|-1|2|2|cell-lborder|1ln>|<cwith|1|1|8|8|cell-tborder|0ln>|<cwith|12|12|8|8|cell-bborder|0ln>|<cwith|1|-1|8|8|cell-lborder|1ln>|<cwith|1|-1|7|7|cell-rborder|1ln>|<cwith|1|-1|8|8|cell-rborder|0ln>|<table|<row|<cell|<math|\<varepsilon\>>>|<cell|<math|m<rsub|1>>>|<cell|<math|m<rsub|2>>>|<cell|<math|m<rsub|3>>>|<cell|<math|m<rsub|4>>>|<cell|<math|m<rsub|5>>>|<cell|<math|m<rsub|6>>>|<cell|<math|p<rsub|1><rsup|\<nu\><rsub|1>>,p<rsub|2><rsup|\<nu\><rsub|2>>,\<ldots\>>>>|<row|<cell|936465>|<cell|543889>|<cell|4920329>|<cell|12408421>|<cell|15115957>|<cell|24645539>|<cell|28167253>|<cell|<math|19,59,417721,\<ldots\>>>>|<row|<cell|2475879>|<cell|867689>|<cell|4051001>|<cell|11023091>|<cell|13219163>|<cell|24046943>|<cell|28290833>|<cell|<math|867689,\<ldots\>>>>|<row|<cell|3205689>|<cell|110161>|<cell|12290741>|<cell|16762897>|<cell|22976783>|<cell|25740731>|<cell|25958183>|<cell|<math|59,79,509,\<ldots\>>>>|<row|<cell|3932205>|<cell|4244431>|<cell|5180213>|<cell|5474789>|<cell|8058377>|<cell|14140817>|<cell|25402873>|<cell|<math|4244431,\<ldots\>>>>|<row|<cell|5665359>|<cell|241739>|<cell|5084221>|<cell|18693097>|<cell|21474613>|<cell|23893447>|<cell|29558531>|<cell|<math|31,41,137,\<ldots\>>>>|<row|<cell|5998191>|<cell|30971>|<cell|21307063>|<cell|21919111>|<cell|22953967>|<cell|31415123>|<cell|33407281>|<cell|<math|101,911,941,\<ldots\>>>>|<row|<cell|6762459>|<cell|3905819>|<cell|5996041>|<cell|7513223>|<cell|7911173>|<cell|8584189>|<cell|29160587>|<cell|<math|43,137,90833,\<ldots\>>>>|<row|<cell|9245919>|<cell|2749717>|<cell|4002833>|<cell|8274689>|<cell|9800633>|<cell|15046937>|<cell|25943587>|<cell|<math|2749717,\<ldots\>>>>|<row|<cell|9655335>|<cell|119809>|<cell|9512309>|<cell|20179259>|<cell|21664469>|<cell|22954369>|<cell|30468101>|<cell|<math|17,89,149,\<ldots\>>>>|<row|<cell|12356475>|<cell|1842887>|<cell|2720359>|<cell|7216357>|<cell|13607779>|<cell|23538769>|<cell|30069449>|<cell|<math|1842887,\<ldots\>>>>|<row|<cell|15257781>|<cell|1012619>|<cell|5408467>|<cell|9547273>|<cell|11431841>|<cell|20472121>|<cell|28474807>|<cell|<math|31,660391,\<ldots\>>>>>>>>>
      List of <math|6>-gentle moduli for <math|w=23>, <math|\<mu\>=25> and
      <math|\<varepsilon\>\<less\>16000000>.
    </big-table*>

    \;

    <math|\<rightsquigarrow\>> Taking <math|w> closer to <math|\<mu\>>
    greatly reduces the number of hits

    <math|\<rightsquigarrow\>> But hits still tend to exist in sufficient
    number
  </hidden>|<\hidden>
    <tit|The gentle modulus hunt (III)>

    \;

    <\big-table*>
      <small|<tabular*|<tformat|<cwith|1|-1|1|-1|cell-halign|r>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|9|9|cell-rborder|0ln>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|11|11|1|1|cell-bborder|0ln>|<cwith|1|-1|1|1|cell-lborder|0ln>|<cwith|1|-1|1|1|cell-rborder|1ln>|<cwith|1|-1|2|2|cell-lborder|1ln>|<cwith|1|1|1|-1|cell-bsep|1spc>|<cwith|2|2|1|-1|cell-tsep|1spc>|<cwith|7|7|1|1|cell-background|dark
      magenta>|<table|<row|<cell|<math|\<varepsilon\>>>|<cell|<math|m<rsub|1>>>|<cell|<math|m<rsub|2>>>|<cell|<math|m<rsub|3>>>|<cell|<math|m<rsub|4>>>|<cell|<math|m<rsub|5>>>|<cell|<math|m<rsub|6>>>|<cell|<math|m<rsub|7>>>|<cell|<math|m<rsub|8>>>>|<row|<cell|889305>|<cell|50551>|<cell|1146547>|<cell|4312709>|<cell|5888899>|<cell|14533283>|<cell|16044143>|<cell|16257529>|<cell|17164793>>|<row|<cell|2447427>|<cell|53407>|<cell|689303>|<cell|3666613>|<cell|4837253>|<cell|7944481>|<cell|21607589>|<cell|25976179>|<cell|32897273>>|<row|<cell|2674557>|<cell|109841>|<cell|1843447>|<cell|2624971>|<cell|5653049>|<cell|7030883>|<cell|8334373>|<cell|18557837>|<cell|29313433>>|<row|<cell|3964365>|<cell|10501>|<cell|2464403>|<cell|6335801>|<cell|9625841>|<cell|10329269>|<cell|13186219>|<cell|17436197>|<cell|25553771>>|<row|<cell|4237383>|<cell|10859>|<cell|3248809>|<cell|5940709>|<cell|6557599>|<cell|9566959>|<cell|11249039>|<cell|22707323>|<cell|28518509>>|<row|<cell|5312763>|<cell|517877>|<cell|616529>|<cell|879169>|<cell|4689089>|<cell|9034687>|<cell|11849077>|<cell|24539909>|<cell|27699229>>|<row|<cell|6785367>|<cell|22013>|<cell|1408219>|<cell|4466089>|<cell|7867589>|<cell|9176941>|<cell|12150997>|<cell|26724877>|<cell|29507689>>|<row|<cell|7929033>|<cell|30781>|<cell|730859>|<cell|4756351>|<cell|9404807>|<cell|13807231>|<cell|15433939>|<cell|19766077>|<cell|22596193>>|<row|<cell|8168565>|<cell|10667>|<cell|3133103>|<cell|3245621>|<cell|6663029>|<cell|15270019>|<cell|18957559>|<cell|20791819>|<cell|22018021>>|<row|<cell|8186205>|<cell|41047>|<cell|2122039>|<cell|2410867>|<cell|6611533>|<cell|9515951>|<cell|14582849>|<cell|16507739>|<cell|30115277>>>>>>
    <|big-table*>
      List of <math|8>-gentle moduli for <math|w=22>, <math|\<mu\>=25> and
      <math|\<varepsilon\>\<less\>10000000>.
    </big-table*>

    \;

    <math|\<rightsquigarrow\>> Increasing <math|s> greatly reduces the number
    of hits

    <math|\<rightsquigarrow\>> Hits continue to exist for
    <math|s\<leqslant\>8>
  </hidden>|<\hidden>
    <tit|The gentle modulus hunt (IV)>

    <\big-table*|<very-small|<tabular*|<tformat|<cwith|1|-1|1|-1|cell-halign|r>|<cwith|10|10|1|-1|cell-tborder|1ln>|<cwith|9|9|1|-1|cell-bborder|1ln>|<cwith|10|10|1|-1|cell-bborder|1ln>|<cwith|11|11|1|-1|cell-tborder|1ln>|<cwith|10|10|3|3|cell-tborder|1ln>|<cwith|9|9|3|3|cell-bborder|1ln>|<cwith|10|10|3|3|cell-bborder|1ln>|<cwith|11|11|3|3|cell-tborder|1ln>|<cwith|10|10|3|3|cell-lborder|0ln>|<cwith|10|10|2|2|cell-rborder|0ln>|<cwith|10|10|3|3|cell-rborder|0ln>|<cwith|10|10|4|4|cell-lborder|0ln>|<cwith|10|10|4|7|cell-halign|r>|<cwith|10|10|4|7|cell-tborder|1ln>|<cwith|10|10|4|7|cell-bborder|1ln>|<cwith|10|10|4|4|cell-tborder|1ln>|<cwith|10|10|4|4|cell-bborder|1ln>|<cwith|10|10|4|4|cell-lborder|0ln>|<cwith|10|10|4|4|cell-rborder|0ln>|<cwith|10|10|5|5|cell-lborder|0ln>|<cwith|10|10|6|6|cell-tborder|1ln>|<cwith|10|10|6|6|cell-bborder|1ln>|<cwith|10|10|6|6|cell-lborder|0ln>|<cwith|10|10|5|5|cell-rborder|0ln>|<cwith|10|10|1|-1|cell-height|2ln>|<cwith|10|10|1|-1|cell-vmode|exact>|<cwith|5|7|4|4|cell-halign|r>|<cwith|7|9|4|4|cell-halign|r>|<cwith|11|13|4|4|cell-halign|r>|<cwith|13|15|4|4|cell-halign|r>|<cwith|1|1|1|-1|cell-tborder|0ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-tborder|1ln>|<cwith|1|1|1|1|cell-tborder|0ln>|<cwith|15|15|1|1|cell-bborder|0ln>|<cwith|1|-1|1|1|cell-lborder|0ln>|<cwith|1|-1|1|1|cell-rborder|1ln>|<cwith|1|-1|2|2|cell-lborder|1ln>|<cwith|1|1|7|7|cell-tborder|0ln>|<cwith|15|15|7|7|cell-bborder|0ln>|<cwith|1|-1|7|7|cell-lborder|1ln>|<cwith|1|-1|6|6|cell-rborder|1ln>|<cwith|1|-1|7|7|cell-rborder|0ln>|<cwith|1|1|1|-1|cell-bsep|1spc>|<cwith|2|2|1|-1|cell-tsep|1spc>|<cwith|10|10|1|1|cell-tborder|1ln>|<cwith|9|9|1|1|cell-bborder|1ln>|<cwith|10|10|1|1|cell-bborder|1ln>|<cwith|11|11|1|1|cell-tborder|1ln>|<cwith|10|10|1|1|cell-lborder|0ln>|<cwith|10|10|1|1|cell-rborder|0ln>|<cwith|10|10|2|2|cell-lborder|0ln>|<cwith|10|10|7|7|cell-tborder|1ln>|<cwith|9|9|7|7|cell-bborder|1ln>|<cwith|10|10|7|7|cell-bborder|1ln>|<cwith|11|11|7|7|cell-tborder|1ln>|<cwith|10|10|7|7|cell-lborder|0ln>|<cwith|10|10|6|6|cell-rborder|0ln>|<cwith|10|10|7|7|cell-rborder|0ln>|<cwith|11|15|1|1|cell-background|dark
    magenta>|<cwith|13|13|7|7|cell-background|dark
    magenta>|<cwith|15|15|7|7|cell-background|dark
    magenta>|<table|<row|<cell|<math|\<varepsilon\>>>|<cell|<math|m<rsub|1>>>|<cell|<math|m<rsub|2>>>|<cell|<math|\<cdots\>>>|<cell|<math|m<rsub|5>>>|<cell|<math|m<rsub|6>>>|<cell|<math|p<rsub|1><rsup|\<nu\><rsub|1>>,p<rsub|2><rsup|\<nu\><rsub|2>>,\<ldots\>>>>|<row|<cell|15123>|<cell|380344780931>|<cell|774267432193>|<cell|<math|\<cdots\>>>|<cell|463904018985637>|<cell|591951338196847>|<cell|<math|37,47,239,\<ldots\>>>>|<row|<cell|34023>|<cell|9053503517>|<cell|13181369695139>|<cell|<math|\<cdots\>>>|<cell|680835893479031>|<cell|723236090375863>|<cell|<math|29,35617,\<ldots\>>>>|<row|<cell|40617>|<cell|3500059133>|<cell|510738813367>|<cell|<math|\<cdots\>>>|<cell|824394263006533>|<cell|1039946916817703>|<cell|<math|23,61,347,\<ldots\>>>>|<row|<cell|87363>|<cell|745270007>|<cell|55797244348441>|<cell|<math|\<cdots\>>>|<cell|224580313861483>|<cell|886387548974947>|<cell|<math|71,9209,\<ldots\>>>>|<row|<cell|95007>|<cell|40134716987>|<cell|2565724842229>|<cell|<math|\<cdots\>>>|<cell|130760921456911>|<cell|393701833767607>|<cell|<math|19,67,\<ldots\>>>>|<row|<cell|101307>|<cell|72633113401>|<cell|12070694419543>|<cell|<math|\<cdots\>>>|<cell|95036720090209>|<cell|183377870340761>|<cell|<math|41,401,\<ldots\>>>>|<row|<cell|140313>|<cell|13370367761>|<cell|202513228811>|<cell|<math|\<cdots\>>>|<cell|397041457462499>|<cell|897476961701171>|<cell|<math|379,1187,\<ldots\>>>>|<row|<cell|193533>|<cell|35210831>|<cell|15416115621749>|<cell|<math|\<cdots\>>>|<cell|727365428298107>|<cell|770048329509499>|<cell|<math|59,79,\<ldots\>>>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>|<cell|>>|<row|<cell|519747>|<cell|34123521053>|<cell|685883716741>|<cell|<math|\<cdots\>>>|<cell|705516472454581>|<cell|836861326275781>|<cell|<math|127,587,\<ldots\>>>>|<row|<cell|637863>|<cell|554285276371>|<cell|1345202287357>|<cell|<math|\<cdots\>>>|<cell|344203886091451>|<cell|463103013579761>|<cell|<math|79,1979,\<ldots\>>>>|<row|<cell|775173>|<cell|322131291353>|<cell|379775454593>|<cell|<math|\<cdots\>>>|<cell|194236314135719>|<cell|1026557288284007>|<cell|<math|322131291353,\<ldots\>>>>|<row|<cell|913113>|<cell|704777248393>|<cell|1413212491811>|<cell|<math|\<cdots\>>>|<cell|217740328855369>|<cell|261977228819083>|<cell|<math|37,163,677,\<ldots\>>>>|<row|<cell|1400583>|<cell|21426322331>|<cell|42328735049>|<cell|<math|\<cdots\>>>|<cell|411780268096919>|<cell|626448556280293>|<cell|<math|21426322331,\<ldots\>>>>>>>>>
      List of <math|6>-gentle moduli for <math|w=44>, <math|\<mu\>=50> and
      <math|\<varepsilon\>\<less\>200000>. Followed by some super-gentle
      ones.
    </big-table*>

    \;

    <math|\<rightsquigarrow\>> Doubling <math|w> and <math|\<mu\>> tends to
    yield a much larger number of hits

    <math|\<rightsquigarrow\>> Sieving needs to be further optimized

    <math|\<rightsquigarrow\>> Suggestion for <name|Pari-GP>: an efficient
    routine for <math|B>-smooth factorization
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|emboss-color|#c84>
    <associate|emboss-dx|-1ln>
    <associate|emboss-dy|-1ln>
    <associate|font|Chalkboard>
    <associate|font-family|rm>
    <associate|info-flag|minimal>
    <associate|ornament-extra-color|<pattern|paper-manila-medium.png||>>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|table>
      <\tuple|normal>
        List of <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|6>>-gentle
        moduli for <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|w=22>>,
        <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mu\>=25>>,
        and <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<varepsilon\>\<less\>1000000>>.
      </tuple|<pageref|auto-1>>

      <\tuple|normal>
        List of <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|6>>-gentle
        moduli for <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|w=23>>,
        <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mu\>=25>>
        and <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<varepsilon\>\<less\>16000000>>.
      </tuple|<pageref|auto-2>>

      <\tuple|normal>
        List of <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|8>>-gentle
        moduli for <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|w=22>>,
        <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mu\>=25>>
        and <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<varepsilon\>\<less\>10000000>>.
      </tuple|<pageref|auto-3>>

      <\tuple|normal>
        List of <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|6>>-gentle
        moduli for <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|w=44>>,
        <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<mu\>=50>>
        and <with|color|<quote|#ffffd0>|font-family|<quote|rm>|<with|mode|<quote|math>|\<varepsilon\>\<less\>200000>>.
        Followed by some super-gentle ones.
      </tuple|<pageref|auto-4>>
    </associate>
  </collection>
</auxiliary>